/*
//	Note:  The use of this program shall be restricted to educational,
//	non-commercial use only.  All inquiries regarding licensing this
//	software for commercial use may be addressed to:
//	
//	Georgia Tech Research Corporation
//	Technology Licensing
//	Centennial Research Building - Rm. 275
//	400 Tenth Street, N.W.
//	Atlanta, Georgia  30332-0415
//	
//	*************************************************
//	
//	       Copyright 1996
//	Georgia Tech Research Corporation
//	    All Rights Reserved
//
//
//
 * Header info for the client-side GC cache.
 *
 * 	Written by Sue Long <suelong@cc.gatech.edu>
 *	Clean-up by Keith Edwards <keith@cc.gatech.edu>
 *
 */

#ifndef _X_GC_LIST_H_
#define _X_GC_LIST_H_

#include <X11/Xlib.h>

typedef struct _XGCListEntry {
    GC gc;
    Display *dpy;
    struct _XGCListEntry *next;
} XGCListEntry, *XGCListPtr;

extern XGCListPtr XGCGetListHead();  
extern void XGCSetListHead(XGCListPtr);  
extern GC XGCFromGContext(Display *, GContext);  

#endif /* _X_GC_LIST_H_ */
