/*
//	Note:  The use of this program shall be restricted to educational,
//	non-commercial use only.  All inquiries regarding licensing this
//	software for commercial use may be addressed to:
//	
//	Georgia Tech Research Corporation
//	Technology Licensing
//	Centennial Research Building - Rm. 275
//	400 Tenth Street, N.W.
//	Atlanta, Georgia  30332-0415
//	
//	*************************************************
//	
//	       Copyright 1996
//	Georgia Tech Research Corporation
//	    All Rights Reserved
//
//
//
 *
 */

#ifndef _CLIENT_H_
#define _CLIENT_H_

#include <X11/Intrinsic.h>	/* for Widget */
#include <X11/ICE/ICEconn.h>	/* for IceConn */

#define RAP_DEBUG

int HandleRapHelloRequest(IceConn, int);
int HandleRapQueryTreeRequest(IceConn, int, Widget);
int HandleRapGetValuesRequest(IceConn, int);
int HandleRapGetResourcesRequest(IceConn, int);
int HandleRapAddNotifyRequest(IceConn, int);
int HandleRapRemoveNotifyRequest(IceConn, int);
int HandleRapSelectEventRequest(IceConn, int);
int HandleRapSelectRequestRequest(IceConn, int);
int HandleRapLocateObjectRequest(IceConn, int);

int RAPHelloReply(IceConn, int);
int RAPQueryTreeReply(IceConn, int, Widget);
int RAPGetValuesReply(IceConn, int, Widget, CARD32, char **);
int RAPLocateObjectReply(IceConn, majorOpcode, CARD32, WidgetList);
int RAPGetResourcesReply(IceConn, majorOpcode, CARD32, WidgetList);

#endif /* _CLIENT_H_ */

			 
