/*
//	Note:  The use of this program shall be restricted to educational,
//	non-commercial use only.  All inquiries regarding licensing this
//	software for commercial use may be addressed to:
//	
//	Georgia Tech Research Corporation
//	Technology Licensing
//	Centennial Research Building - Rm. 275
//	400 Tenth Street, N.W.
//	Atlanta, Georgia  30332-0415
//	
//	*************************************************
//	
//	       Copyright 1996
//	Georgia Tech Research Corporation
//	    All Rights Reserved
//
//
//
*/
/************************************************************************/
/*									*/
/* Xtea.h								*/
/*									*/
/* 	Header file for the Xt external agent enabling code.  This	*/
/*	file is meant to be used mainly by procotols that are used by	*/
/*	external agents (i.e., it is not meant to be included by normal	*/
/*	Xt clients.							*/
/*									*/
/************************************************************************/
/* Atoms
 */
#define EXTAGENT_NAME	"ExternalAgent"
#define ICE_NETWORK_IDS	"IceNetworkIds"

/* Format for the client message event data.
 */
#define EXTAGENT_FORMAT	32

/* The initializer functions take a widget as an argument (which they can
 * then use to retrieve an app context, display, or whatever) as well as
 * the list of ICE network ID's for the agent.  There is no return value 
 * to indicate success or failure, as there is no easy way to pass it back 
 * (XtSelectionCallbackProc has no return value).
 */
typedef void (*XteaProtoInitializer)(Widget,char *);

/* Known Protocols
 */
#define RAP
