#ifndef lint
static char filtersccsid[] = "@(#)yaccpar	1.9 (Berkeley) 02/21/93";
#endif
#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define filterclearin (filterchar=(-1))
#define filtererrok (filtererrflag=0)
#define YYRECOVERING (filtererrflag!=0)
#define YYPREFIX "filter"
/*
//
//
//	Note:  The use of this program shall be restricted to educational,
//	non-commercial use only.  All inquiries regarding licensing this
//	software for commercial use may be addressed to:
//	
//	Georgia Tech Research Corporation
//	Technology Licensing
//	Centennial Research Building - Rm. 275
//	400 Tenth Street, N.W.
//	Atlanta, Georgia  30332-0415
//	
//	*************************************************
//	
//	       Copyright 1996
//	Georgia Tech Research Corporation
//	    All Rights Reserved
//
//
//
*/

#include <string.h>

#include "Error.h"
#include "ScreenReader.h"

typedef union {
    long	integer;	/* integer return */
    char	*string;	/* string return */
#ifdef BEAM
    unsigned char bbool;	/* boolean return */
#else
    unsigned char bool;		/* boolean return */
#endif
} YYSTYPE;
#define INTEGER 257
#define IDENTIFIER 258
#define REGEXP 259
#define FILTER 260
#define LANGUAGE 261
#define PITCH 262
#define RATE 263
#define VOICE 264
#define VOLUME 265
#define FONT 266
#define HIGHLIGHT 267
#define BOOLEAN 268
#define YYERRCODE 256
short filterlhs[] = {                                        -1,
    0,    0,    3,    4,    5,    6,    6,    6,    8,    7,
    7,    7,    7,    7,    7,    2,    1,    1,    1,    1,
    1,
};
short filterlen[] = {                                         2,
    0,    2,    2,    2,    3,    0,    2,    2,    3,    2,
    2,    2,    2,    2,    2,    2,    1,    1,    1,    1,
    1,
};
short filterdefred[] = {                                      1,
    0,    0,    2,    0,    4,    6,    3,    0,    0,    0,
    0,    0,    5,    7,    8,    0,   11,   17,   18,   19,
   20,   21,    0,   10,   13,   12,   15,   14,    9,   16,
};
short filterdgoto[] = {                                       1,
   23,   24,    3,    4,    7,    8,   14,   15,
};
short filtersindex[] = {                                      0,
 -236, -256,    0, -114,    0,    0,    0, -125,  -45, -258,
 -251, -244,    0,    0,    0, -233,    0,    0,    0,    0,
    0,    0, -232,    0,    0,    0,    0,    0,    0,    0,
};
short filterrindex[] = {                                      0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
};
short filtergindex[] = {                                      0,
    0,   11,    0,    0,    0,    0,    0,    0,
};
#define YYTABLESIZE 142
short filtertable[] = {                                      13,
   17,    5,   18,   19,   20,   21,   22,   25,    6,   18,
   19,   20,   21,   22,   27,   16,   18,   19,   20,   21,
   22,   26,   28,    2,   29,   30,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    9,   10,    0,    0,    0,    0,    0,    0,
   11,   12,
};
short filtercheck[] = {                                     125,
  259,  258,  261,  262,  263,  264,  265,  259,  123,  261,
  262,  263,  264,  265,  259,   61,  261,  262,  263,  264,
  265,   11,   12,  260,  258,  258,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  258,  259,   -1,   -1,   -1,   -1,   -1,   -1,
  266,  267,
};
#define YYFINAL 1
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 268
#if YYDEBUG
char *filtername[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"'='",0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,"'{'",0,"'}'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"INTEGER",
"IDENTIFIER","REGEXP","FILTER","LANGUAGE","PITCH","RATE","VOICE","VOLUME",
"FONT","HIGHLIGHT","BOOLEAN",
};
char *filterrule[] = {
"$accept : file",
"file :",
"file : file filter",
"filter : filterhdr filterbody",
"filterhdr : FILTER IDENTIFIER",
"filterbody : '{' rules '}'",
"rules :",
"rules : rules rule",
"rules : rules option",
"option : IDENTIFIER '=' IDENTIFIER",
"rule : REGEXP action",
"rule : REGEXP REGEXP",
"rule : FONT action",
"rule : FONT REGEXP",
"rule : HIGHLIGHT action",
"rule : HIGHLIGHT REGEXP",
"action : operation IDENTIFIER",
"operation : LANGUAGE",
"operation : PITCH",
"operation : RATE",
"operation : VOICE",
"operation : VOLUME",
};
#endif
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 500
#define YYMAXDEPTH 500
#endif
#endif
int filterdebug;
int filternerrs;
int filtererrflag;
int filterchar;
short *filterssp;
YYSTYPE *filtervsp;
YYSTYPE filterval;
YYSTYPE filterlval;
short filterss[YYSTACKSIZE];
YYSTYPE filtervs[YYSTACKSIZE];
#define filterstacksize YYSTACKSIZE

#include "filterlexer.cc"

/*
 * Replacements for filterwrap and filtererror.  These keep us from having to link
 * with libraries we really don't need.
 */

int
filterwrap()
{
    return 1;
}

static int
filtererror(char *str)
{
	char buffer[16];
	sprintf(buffer, "%d", FilterDict::filterLineCount);
	if (str) {
		if (FilterDict::current_filter)
			Error(EL_ERROR, "Error parsing filter ",
				FilterDict::current_filter->GetName(),
				" at line ", buffer, ".  Aborting.\n", NULL);
		else
			Error(EL_ERROR, 
				"Illegal filter syntax at line ", buffer,
				".  Aborting.\n", NULL);
		FilterDict::NewFilterAbort();
	}
	else
		printf("error: null error string in filtererror.\n");
	return 1;
}

#define YYABORT goto filterabort
#define YYREJECT goto filterabort
#define YYACCEPT goto filteraccept
#define YYERROR goto filtererrlab
int
filterparse()
{
    register int filterm, filtern, filterstate;
#if YYDEBUG
    register char *filters;
    extern char *getenv();

    if (filters = getenv("YYDEBUG"))
    {
        filtern = *filters;
        if (filtern >= '0' && filtern <= '9')
            filterdebug = filtern - '0';
    }
#endif

    filternerrs = 0;
    filtererrflag = 0;
    filterchar = (-1);

    filterssp = filterss;
    filtervsp = filtervs;
    *filterssp = filterstate = 0;

filterloop:
    if (filtern = filterdefred[filterstate]) goto filterreduce;
    if (filterchar < 0)
    {
        if ((filterchar = filterlex()) < 0) filterchar = 0;
#if YYDEBUG
        if (filterdebug)
        {
            filters = 0;
            if (filterchar <= YYMAXTOKEN) filters = filtername[filterchar];
            if (!filters) filters = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, filterstate, filterchar, filters);
        }
#endif
    }
    if ((filtern = filtersindex[filterstate]) && (filtern += filterchar) >= 0 &&
            filtern <= YYTABLESIZE && filtercheck[filtern] == filterchar)
    {
#if YYDEBUG
        if (filterdebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, filterstate, filtertable[filtern]);
#endif
        if (filterssp >= filterss + filterstacksize - 1)
        {
            goto filteroverflow;
        }
        *++filterssp = filterstate = filtertable[filtern];
        *++filtervsp = filterlval;
        filterchar = (-1);
        if (filtererrflag > 0)  --filtererrflag;
        goto filterloop;
    }
    if ((filtern = filterrindex[filterstate]) && (filtern += filterchar) >= 0 &&
            filtern <= YYTABLESIZE && filtercheck[filtern] == filterchar)
    {
        filtern = filtertable[filtern];
        goto filterreduce;
    }
    if (filtererrflag) goto filterinrecovery;
#ifdef lint
    goto filternewerror;
#endif
filternewerror:
    filtererror("syntax error");
#ifdef lint
    goto filtererrlab;
#endif
filtererrlab:
    ++filternerrs;
filterinrecovery:
    if (filtererrflag < 3)
    {
        filtererrflag = 3;
        for (;;)
        {
            if ((filtern = filtersindex[*filterssp]) && (filtern += YYERRCODE) >= 0 &&
                    filtern <= YYTABLESIZE && filtercheck[filtern] == YYERRCODE)
            {
#if YYDEBUG
                if (filterdebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *filterssp, filtertable[filtern]);
#endif
                if (filterssp >= filterss + filterstacksize - 1)
                {
                    goto filteroverflow;
                }
                *++filterssp = filterstate = filtertable[filtern];
                *++filtervsp = filterlval;
                goto filterloop;
            }
            else
            {
#if YYDEBUG
                if (filterdebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *filterssp);
#endif
                if (filterssp <= filterss) goto filterabort;
                --filterssp;
                --filtervsp;
            }
        }
    }
    else
    {
        if (filterchar == 0) goto filterabort;
#if YYDEBUG
        if (filterdebug)
        {
            filters = 0;
            if (filterchar <= YYMAXTOKEN) filters = filtername[filterchar];
            if (!filters) filters = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, filterstate, filterchar, filters);
        }
#endif
        filterchar = (-1);
        goto filterloop;
    }
filterreduce:
#if YYDEBUG
    if (filterdebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, filterstate, filtern, filterrule[filtern]);
#endif
    filterm = filterlen[filtern];
    filterval = filtervsp[1-filterm];
    switch (filtern)
    {
case 4:
{
		Error(EL_DEBUG, "FilterLoad", "Registering new filter \"",
			filtervsp[0].string, "\".", NULL);
		FilterDict::NewFilterRegister(filtervsp[0].string);
	}
break;
case 5:
{
		FilterDict::NewFilterStore();
	}
break;
case 7:
{	}
break;
case 8:
{	}
break;
case 10:
{	
		FilterDict::NewFilterAdd(filtervsp[-1].string, FILTER_ACTION_REGEXP, filtervsp[0].string);
		delete [] filtervsp[-1].string;
		delete [] filtervsp[0].string;
	}
break;
case 11:
{
		FilterDict::NewFilterAdd(filtervsp[-1].string, FILTER_ACTION_REGEXP, filtervsp[0].string);
		delete [] filtervsp[-1].string;
		delete [] filtervsp[0].string;
	}
break;
case 12:
{	
		FilterDict::NewFilterAdd(filtervsp[-1].string, FILTER_ACTION_FONT, filtervsp[0].string);
		delete [] filtervsp[-1].string;
		delete [] filtervsp[0].string;
	}
break;
case 13:
{
		FilterDict::NewFilterAdd(filtervsp[-1].string, FILTER_ACTION_FONT, filtervsp[0].string);
		delete [] filtervsp[-1].string;
		delete [] filtervsp[0].string;
	}
break;
case 14:
{	
		FilterDict::NewFilterAdd(filtervsp[-1].string, FILTER_ACTION_HIGHLIGHT, filtervsp[0].string);
		delete [] filtervsp[-1].string;
		delete [] filtervsp[0].string;
	}
break;
case 15:
{
		FilterDict::NewFilterAdd(filtervsp[-1].string, FILTER_ACTION_HIGHLIGHT, filtervsp[0].string);
		delete [] filtervsp[-1].string;
		delete [] filtervsp[0].string;
	}
break;
case 16:
{	
		/* parse $1 for action */
		/* parse $2 for action parameters */
		/* query device for appropriate sequences */
		char buffer[512];
		buffer[0] = '\0';
		strcpy(buffer, filtervsp[-1].string);
		strcat(buffer, " ");
		strcat(buffer, filtervsp[0].string);
		delete [] filtervsp[-1].string;
		delete [] filtervsp[0].string;
		filterval.string = Strdup(buffer);
	}
break;
case 21:
{
		filterval.string = filtervsp[0].string;
	}
break;
    }
    filterssp -= filterm;
    filterstate = *filterssp;
    filtervsp -= filterm;
    filterm = filterlhs[filtern];
    if (filterstate == 0 && filterm == 0)
    {
#if YYDEBUG
        if (filterdebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        filterstate = YYFINAL;
        *++filterssp = YYFINAL;
        *++filtervsp = filterval;
        if (filterchar < 0)
        {
            if ((filterchar = filterlex()) < 0) filterchar = 0;
#if YYDEBUG
            if (filterdebug)
            {
                filters = 0;
                if (filterchar <= YYMAXTOKEN) filters = filtername[filterchar];
                if (!filters) filters = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, filterchar, filters);
            }
#endif
        }
        if (filterchar == 0) goto filteraccept;
        goto filterloop;
    }
    if ((filtern = filtergindex[filterm]) && (filtern += filterstate) >= 0 &&
            filtern <= YYTABLESIZE && filtercheck[filtern] == filterstate)
        filterstate = filtertable[filtern];
    else
        filterstate = filterdgoto[filterm];
#if YYDEBUG
    if (filterdebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *filterssp, filterstate);
#endif
    if (filterssp >= filterss + filterstacksize - 1)
    {
        goto filteroverflow;
    }
    *++filterssp = filterstate;
    *++filtervsp = filterval;
    goto filterloop;
filteroverflow:
    filtererror("yacc stack overflow");
filterabort:
    return (1);
filteraccept:
    return (0);
}
