##
##
##
##	Note:  The use of this program shall be restricted to educational,
##	non-commercial use only.  All inquiries regarding licensing this
##	software for commercial use may be addressed to:
##	
##	Georgia Tech Research Corporation
##	Technology Licensing
##	Centennial Research Building - Rm. 275
##	400 Tenth Street, N.W.
##	Atlanta, Georgia  30332-0415
##	
##	*************************************************
##	
##	       Copyright 1996
##	Georgia Tech Research Corporation
##	    All Rights Reserved
##
##
##
##

Error EL_DEBUG log "Sourcing log.tcl"

set logFile "NULL"

proc testlogging args {
    logtofile /tmp/foobar.1 "[short2long [currentObject]]"  [currentClient] $foo
}

## ADDED BY KEITH for debugging
proc LogOn {filename} {
    global logFile
    set logFile $filename
    #puts "LOGGING TO FILE $filename"
}

proc StartTrial {subjectNum half block interface} {
    global logFile

    set logFile "datalog:$subjectNum:$half:$block"
    StartTimer $logFile StartTrial $subjectNum $half $block $interface

}

proc ButtonPress {button obj client} {
    global logFile
    logtofile $logFile ButtonPress $button [modelManager longname $obj]
}

proc EnterNotify {obj client} {
    global logFile
    logtofile $logFile EnterNotify [modelManager longname $obj]
}


addaction ButtonPress
addaction EnterNotify
addaction StartTrial
addaction StartTimer



