#include <stdio.h>
# define U(x) x
# define NLSTATE tmplprevious=YYNEWLINE
# define BEGIN tmplbgin = tmplsvec + 1 +
# define INITIAL 0
# define YYLERR tmplsvec
# define YYSTATE (tmplestate-tmplsvec-1)
# define YYOPTIM 1
# define YYLMAX BUFSIZ
#ifndef __cplusplus
# define output(c) (void)putc(c,tmplout)
#else
# define lex_output(c) (void)putc(c,tmplout)
#endif

#if defined(__cplusplus) || defined(__STDC__)

#if defined(__cplusplus) && defined(__EXTERN_C__)
extern "C" {
#endif
	int tmplback(int *, int);
	int tmplinput(void);
	int tmpllook(void);
	void tmploutput(int);
	int tmplracc(int);
	int tmplreject(void);
	void tmplunput(int);
	int tmpllex(void);
#ifdef YYLEX_E
	void tmplwoutput(wchar_t);
	wchar_t tmplwinput(void);
#endif
#ifndef tmplless
	void tmplless(int);
#endif
#ifndef tmplwrap
	int tmplwrap(void);
#endif
#ifdef LEXDEBUG
	void allprint(char);
	void sprint(char *);
#endif
#if defined(__cplusplus) && defined(__EXTERN_C__)
}
#endif

#ifdef __cplusplus
extern "C" {
#endif
	void exit(int);
#ifdef __cplusplus
}
#endif

#endif
# define unput(c) {tmpltchar= (c);if(tmpltchar=='\n')tmpllineno--;*tmplsptr++=tmpltchar;}
# define tmplmore() (tmplmorfg=1)
#ifndef __cplusplus
# define input() (((tmpltchar=tmplsptr>tmplsbuf?U(*--tmplsptr):getc(tmplin))==10?(tmpllineno++,tmpltchar):tmpltchar)==EOF?0:tmpltchar)
#else
# define lex_input() (((tmpltchar=tmplsptr>tmplsbuf?U(*--tmplsptr):getc(tmplin))==10?(tmpllineno++,tmpltchar):tmpltchar)==EOF?0:tmpltchar)
#endif
#define ECHO fprintf(tmplout, "%s",tmpltext)
# define REJECT { nstr = tmplreject(); goto tmplfussy;}
int tmplleng; extern char tmpltext[];
int tmplmorfg;
extern char *tmplsptr, tmplsbuf[];
int tmpltchar;
FILE *tmplin = {stdin}, *tmplout = {stdout};
extern int tmpllineno;
struct tmplsvf { 
	struct tmplwork *tmplstoff;
	struct tmplsvf *tmplother;
	int *tmplstops;};
struct tmplsvf *tmplestate;
extern struct tmplsvf tmplsvec[], *tmplbgin;


# line 5 "templates.l"
/*
//
//
//	Note:  The use of this program shall be restricted to educational,
//	non-commercial use only.  All inquiries regarding licensing this
//	software for commercial use may be addressed to:
//	
//	Georgia Tech Research Corporation
//	Technology Licensing
//	Centennial Research Building - Rm. 275
//	400 Tenth Street, N.W.
//	Atlanta, Georgia  30332-0415
//	
//	*************************************************
//	
//	       Copyright 1996
//	Georgia Tech Research Corporation
//	    All Rights Reserved
//
//
//
*/

void NewObjTemplate(int l, const char *name);
void NewClassTemplate(int l, const char *name);
void NewAppTemplate(int l, const char *name);

void EndTemplate(int l);

void ProcessBooleanField(int l, const char *id, unsigned char b);
void ProcessIntegerField(int l, const char *id, long i);
void ProcessStringField(int l, const char *id, const char *s);
void ProcessStringListField(int l, const char *id);
void ProcessProcField(int l, const char *id, const char *proc);

void TmplAddToStringList(int l, const char *s);
void TmplLexWarning(int l, const char *s);

# define YYNEWLINE 10
tmpllex(){
int nstr; extern int tmplprevious;
#ifdef __cplusplus
/* to avoid CC and lint complaining tmplfussy not being used ...*/
static int __lex_hack = 0;
if (__lex_hack) goto tmplfussy;
#endif
while((nstr = tmpllook()) >= 0)
tmplfussy: switch(nstr){
case 0:
if(tmplwrap()) return(0); break;
case 1:

# line 40 "templates.l"
;
break;
case 2:

# line 41 "templates.l"
{	
			templateLineno++;
		}
break;
case 3:

# line 44 "templates.l"
;
break;
case 4:

# line 45 "templates.l"
{
			sscanf(tmpltext, "%d", &tmpllval.integer);
			return INTEGER;
		}
break;
case 5:

# line 49 "templates.l"
{	return OBJ_TEMPLATE;	}
break;
case 6:

# line 50 "templates.l"
{	return CLASS_TEMPLATE;	}
break;
case 7:

# line 51 "templates.l"
{	return APP_TEMPLATE;	}
break;
case 8:

# line 52 "templates.l"
	{
			tmpllval.bool = 1;
			return BOOLEAN;
		}
break;
case 9:

# line 56 "templates.l"
	{
			tmpllval.bool = 0;
			return BOOLEAN;
		}
break;
case 10:

# line 60 "templates.l"
{
			register int i;
			tmpllval.string = strdup(tmpltext);
			if (tmpllval.string[strlen(tmpllval.string) - 1] != '"') {
			    TmplLexWarning(templateLineno, 
				"unterminated string");
			}
			for (i=0 ; i<(int)strlen(tmpllval.string) ; i++) {
			    tmpllval.string[i] = tmpllval.string[i+1];
			}
			tmpllval.string[strlen(tmpllval.string) - 1] = '\0';
			return STRING;
		}
break;
case 11:

# line 73 "templates.l"
{
			tmpllval.identifier = strdup(tmpltext);
			return IDENTIFIER;
		}
break;
case 12:

# line 77 "templates.l"
	{ 	return tmpltext[0];	}
break;
case -1:
break;
default:
(void)fprintf(tmplout,"bad switch tmpllook %d",nstr);
} return(0); }
/* end of tmpllex */
int tmplvstop[] = {
0,

12,
0,

1,
12,
0,

2,
0,

12,
0,

3,
12,
0,

4,
12,
0,

11,
12,
0,

11,
12,
0,

11,
12,
0,

11,
12,
0,

11,
12,
0,

11,
12,
0,

1,
0,

10,
0,

3,
0,

4,
0,

11,
0,

11,
0,

11,
0,

11,
0,

11,
0,

11,
0,

11,
0,

11,
0,

11,
0,

11,
0,

11,
0,

11,
0,

8,
11,
0,

11,
0,

11,
0,

11,
0,

9,
11,
0,

11,
0,

11,
0,

11,
0,

11,
0,

11,
0,

11,
0,

11,
0,

11,
0,

11,
0,

11,
0,

11,
0,

11,
0,

11,
0,

11,
0,

11,
0,

11,
0,

11,
0,

11,
0,

7,
11,
0,

11,
0,

11,
0,

11,
0,

11,
0,

6,
11,
0,

11,
0,

5,
11,
0,
0};
# define YYTYPE unsigned char
struct tmplwork { YYTYPE verify, advance; } tmplcrank[] = {
0,0,	0,0,	1,3,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	6,16,	1,4,	1,5,	
18,0,	0,0,	7,18,	4,15,	
0,0,	6,16,	6,17,	0,0,	
0,0,	0,0,	7,18,	7,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	1,6,	
1,7,	2,7,	4,15,	0,0,	
0,0,	0,0,	6,17,	0,0,	
0,0,	0,0,	1,3,	7,18,	
0,0,	1,8,	0,0,	0,0,	
0,0,	6,16,	0,0,	0,0,	
6,16,	0,0,	7,18,	0,0,	
0,0,	7,18,	0,0,	0,0,	
0,0,	0,0,	1,9,	10,21,	
0,0,	0,0,	27,32,	1,10,	
2,10,	6,16,	31,36,	0,0,	
0,0,	21,26,	7,18,	0,0,	
0,0,	0,0,	0,0,	11,22,	
26,31,	1,11,	2,11,	8,19,	
8,19,	8,19,	8,19,	8,19,	
8,19,	8,19,	8,19,	8,19,	
8,19,	22,27,	1,12,	2,12,	
1,13,	2,13,	14,25,	24,29,	
28,33,	30,35,	33,37,	25,30,	
35,39,	13,24,	37,40,	38,41,	
1,14,	2,14,	9,20,	9,20,	
12,23,	9,20,	9,20,	9,20,	
9,20,	9,20,	9,20,	9,20,	
9,20,	9,20,	9,20,	23,28,	
29,34,	34,38,	39,42,	40,43,	
41,44,	42,45,	9,20,	9,20,	
9,20,	9,20,	9,20,	9,20,	
9,20,	9,20,	9,20,	9,20,	
9,20,	9,20,	9,20,	9,20,	
9,20,	9,20,	9,20,	9,20,	
9,20,	9,20,	9,20,	9,20,	
9,20,	9,20,	9,20,	9,20,	
43,46,	44,47,	45,48,	46,49,	
9,20,	47,50,	9,20,	9,20,	
9,20,	9,20,	9,20,	9,20,	
9,20,	9,20,	9,20,	9,20,	
9,20,	9,20,	9,20,	9,20,	
9,20,	9,20,	9,20,	9,20,	
9,20,	9,20,	9,20,	9,20,	
9,20,	9,20,	9,20,	9,20,	
48,51,	49,52,	50,53,	51,54,	
52,55,	53,56,	54,57,	56,58,	
57,59,	58,60,	59,61,	61,62,	
0,0};
struct tmplsvf tmplsvec[] = {
0,	0,	0,
tmplcrank+-1,	0,		0,	
tmplcrank+-2,	tmplsvec+1,	0,	
tmplcrank+0,	0,		tmplvstop+1,
tmplcrank+6,	0,		tmplvstop+3,
tmplcrank+0,	0,		tmplvstop+6,
tmplcrank+-8,	0,		tmplvstop+8,
tmplcrank+-13,	0,		tmplvstop+10,
tmplcrank+39,	0,		tmplvstop+13,
tmplcrank+69,	0,		tmplvstop+16,
tmplcrank+2,	tmplsvec+9,	tmplvstop+19,
tmplcrank+1,	tmplsvec+9,	tmplvstop+22,
tmplcrank+4,	tmplsvec+9,	tmplvstop+25,
tmplcrank+1,	tmplsvec+9,	tmplvstop+28,
tmplcrank+4,	tmplsvec+9,	tmplvstop+31,
tmplcrank+0,	tmplsvec+4,	tmplvstop+34,
tmplcrank+0,	tmplsvec+6,	0,	
tmplcrank+0,	0,		tmplvstop+36,
tmplcrank+-2,	tmplsvec+7,	tmplvstop+38,
tmplcrank+0,	tmplsvec+8,	tmplvstop+40,
tmplcrank+0,	tmplsvec+9,	tmplvstop+42,
tmplcrank+1,	tmplsvec+9,	tmplvstop+44,
tmplcrank+12,	tmplsvec+9,	tmplvstop+46,
tmplcrank+15,	tmplsvec+9,	tmplvstop+48,
tmplcrank+6,	tmplsvec+9,	tmplvstop+50,
tmplcrank+1,	tmplsvec+9,	tmplvstop+52,
tmplcrank+1,	tmplsvec+9,	tmplvstop+54,
tmplcrank+1,	tmplsvec+9,	tmplvstop+56,
tmplcrank+20,	tmplsvec+9,	tmplvstop+58,
tmplcrank+13,	tmplsvec+9,	tmplvstop+60,
tmplcrank+4,	tmplsvec+9,	tmplvstop+62,
tmplcrank+5,	tmplsvec+9,	tmplvstop+64,
tmplcrank+0,	tmplsvec+9,	tmplvstop+66,
tmplcrank+5,	tmplsvec+9,	tmplvstop+69,
tmplcrank+14,	tmplsvec+9,	tmplvstop+71,
tmplcrank+9,	tmplsvec+9,	tmplvstop+73,
tmplcrank+0,	tmplsvec+9,	tmplvstop+75,
tmplcrank+1,	tmplsvec+9,	tmplvstop+78,
tmplcrank+27,	tmplsvec+9,	tmplvstop+80,
tmplcrank+14,	tmplsvec+9,	tmplvstop+82,
tmplcrank+19,	tmplsvec+9,	tmplvstop+84,
tmplcrank+31,	tmplsvec+9,	tmplvstop+86,
tmplcrank+49,	tmplsvec+9,	tmplvstop+88,
tmplcrank+52,	tmplsvec+9,	tmplvstop+90,
tmplcrank+52,	tmplsvec+9,	tmplvstop+92,
tmplcrank+61,	tmplsvec+9,	tmplvstop+94,
tmplcrank+66,	tmplsvec+9,	tmplvstop+96,
tmplcrank+53,	tmplsvec+9,	tmplvstop+98,
tmplcrank+83,	tmplsvec+9,	tmplvstop+100,
tmplcrank+77,	tmplsvec+9,	tmplvstop+102,
tmplcrank+86,	tmplsvec+9,	tmplvstop+104,
tmplcrank+83,	tmplsvec+9,	tmplvstop+106,
tmplcrank+95,	tmplsvec+9,	tmplvstop+108,
tmplcrank+100,	tmplsvec+9,	tmplvstop+110,
tmplcrank+90,	tmplsvec+9,	tmplvstop+112,
tmplcrank+0,	tmplsvec+9,	tmplvstop+114,
tmplcrank+83,	tmplsvec+9,	tmplvstop+117,
tmplcrank+103,	tmplsvec+9,	tmplvstop+119,
tmplcrank+100,	tmplsvec+9,	tmplvstop+121,
tmplcrank+86,	tmplsvec+9,	tmplvstop+123,
tmplcrank+0,	tmplsvec+9,	tmplvstop+125,
tmplcrank+102,	tmplsvec+9,	tmplvstop+128,
tmplcrank+0,	tmplsvec+9,	tmplvstop+130,
0,	0,	0};
struct tmplwork *tmpltop = tmplcrank+203;
struct tmplsvf *tmplbgin = tmplsvec+1;
char tmplmatch[] = {
  0,   1,   1,   1,   1,   1,   1,   1, 
  1,   9,  10,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  9,   1,  34,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,  45,  45,   1, 
 48,  48,  48,  48,  48,  48,  48,  48, 
 48,  48,   1,   1,   1,   1,   1,   1, 
  1,  65,  65,  65,  65,  65,  65,  65, 
 65,  65,  65,  65,  65,  65,  65,  65, 
 65,  65,  65,  65,  65,  65,  65,  65, 
 65,  65,  65,   1,   1,   1,   1,  45, 
  1,  65,  65,  65,  65,  65,  65,  65, 
 65,  65,  65,  65,  65,  65,  65,  65, 
 65,  65,  65,  65,  65,  65,  65,  65, 
 65,  65,  65,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
0};
char tmplextra[] = {
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0};
/*	Copyright (c) 1989 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

#pragma ident	"@(#)ncform	6.7	93/06/07 SMI"

int tmpllineno =1;
# define YYU(x) x
# define NLSTATE tmplprevious=YYNEWLINE
char tmpltext[YYLMAX];
struct tmplsvf *tmpllstate [YYLMAX], **tmpllsp, **tmplolsp;
char tmplsbuf[YYLMAX];
char *tmplsptr = tmplsbuf;
int *tmplfnd;
extern struct tmplsvf *tmplestate;
int tmplprevious = YYNEWLINE;
#if defined(__cplusplus) || defined(__STDC__)
int tmpllook(void)
#else
tmpllook()
#endif
{
	register struct tmplsvf *tmplstate, **lsp;
	register struct tmplwork *tmplt;
	struct tmplsvf *tmplz;
	int tmplch, tmplfirst;
	struct tmplwork *tmplr;
# ifdef LEXDEBUG
	int debug;
# endif
	char *tmpllastch;
	/* start off machines */
# ifdef LEXDEBUG
	debug = 0;
# endif
	tmplfirst=1;
	if (!tmplmorfg)
		tmpllastch = tmpltext;
	else {
		tmplmorfg=0;
		tmpllastch = tmpltext+tmplleng;
		}
	for(;;){
		lsp = tmpllstate;
		tmplestate = tmplstate = tmplbgin;
		if (tmplprevious==YYNEWLINE) tmplstate++;
		for (;;){
# ifdef LEXDEBUG
			if(debug)fprintf(tmplout,"state %d\n",tmplstate-tmplsvec-1);
# endif
			tmplt = tmplstate->tmplstoff;
			if(tmplt == tmplcrank && !tmplfirst){  /* may not be any transitions */
				tmplz = tmplstate->tmplother;
				if(tmplz == 0)break;
				if(tmplz->tmplstoff == tmplcrank)break;
				}
#ifndef __cplusplus
			*tmpllastch++ = tmplch = input();
#else
			*tmpllastch++ = tmplch = lex_input();
#endif
			if(tmpllastch > &tmpltext[YYLMAX]) {
				fprintf(tmplout,"Input string too long, limit %d\n",YYLMAX);
				exit(1);
			}
			tmplfirst=0;
		tryagain:
# ifdef LEXDEBUG
			if(debug){
				fprintf(tmplout,"char ");
				allprint(tmplch);
				putchar('\n');
				}
# endif
			tmplr = tmplt;
			if ( (int)tmplt > (int)tmplcrank){
				tmplt = tmplr + tmplch;
				if (tmplt <= tmpltop && tmplt->verify+tmplsvec == tmplstate){
					if(tmplt->advance+tmplsvec == YYLERR)	/* error transitions */
						{unput(*--tmpllastch);break;}
					*lsp++ = tmplstate = tmplt->advance+tmplsvec;
					if(lsp > &tmpllstate[YYLMAX]) {
						fprintf(tmplout,"Input string too long, limit %d\n",YYLMAX);
						exit(1);
					}
					goto contin;
					}
				}
# ifdef YYOPTIM
			else if((int)tmplt < (int)tmplcrank) {		/* r < tmplcrank */
				tmplt = tmplr = tmplcrank+(tmplcrank-tmplt);
# ifdef LEXDEBUG
				if(debug)fprintf(tmplout,"compressed state\n");
# endif
				tmplt = tmplt + tmplch;
				if(tmplt <= tmpltop && tmplt->verify+tmplsvec == tmplstate){
					if(tmplt->advance+tmplsvec == YYLERR)	/* error transitions */
						{unput(*--tmpllastch);break;}
					*lsp++ = tmplstate = tmplt->advance+tmplsvec;
					if(lsp > &tmpllstate[YYLMAX]) {
						fprintf(tmplout,"Input string too long, limit %d\n",YYLMAX);
						exit(1);
					}
					goto contin;
					}
				tmplt = tmplr + YYU(tmplmatch[tmplch]);
# ifdef LEXDEBUG
				if(debug){
					fprintf(tmplout,"try fall back character ");
					allprint(YYU(tmplmatch[tmplch]));
					putchar('\n');
					}
# endif
				if(tmplt <= tmpltop && tmplt->verify+tmplsvec == tmplstate){
					if(tmplt->advance+tmplsvec == YYLERR)	/* error transition */
						{unput(*--tmpllastch);break;}
					*lsp++ = tmplstate = tmplt->advance+tmplsvec;
					if(lsp > &tmpllstate[YYLMAX]) {
						fprintf(tmplout,"Input string too long, limit %d\n",YYLMAX);
						exit(1);
					}
					goto contin;
					}
				}
			if ((tmplstate = tmplstate->tmplother) && (tmplt= tmplstate->tmplstoff) != tmplcrank){
# ifdef LEXDEBUG
				if(debug)fprintf(tmplout,"fall back to state %d\n",tmplstate-tmplsvec-1);
# endif
				goto tryagain;
				}
# endif
			else
				{unput(*--tmpllastch);break;}
		contin:
# ifdef LEXDEBUG
			if(debug){
				fprintf(tmplout,"state %d char ",tmplstate-tmplsvec-1);
				allprint(tmplch);
				putchar('\n');
				}
# endif
			;
			}
# ifdef LEXDEBUG
		if(debug){
			fprintf(tmplout,"stopped at %d with ",*(lsp-1)-tmplsvec-1);
			allprint(tmplch);
			putchar('\n');
			}
# endif
		while (lsp-- > tmpllstate){
			*tmpllastch-- = 0;
			if (*lsp != 0 && (tmplfnd= (*lsp)->tmplstops) && *tmplfnd > 0){
				tmplolsp = lsp;
				if(tmplextra[*tmplfnd]){		/* must backup */
					while(tmplback((*lsp)->tmplstops,-*tmplfnd) != 1 && lsp > tmpllstate){
						lsp--;
						unput(*tmpllastch--);
						}
					}
				tmplprevious = YYU(*tmpllastch);
				tmpllsp = lsp;
				tmplleng = tmpllastch-tmpltext+1;
				tmpltext[tmplleng] = 0;
# ifdef LEXDEBUG
				if(debug){
					fprintf(tmplout,"\nmatch ");
					sprint(tmpltext);
					fprintf(tmplout," action %d\n",*tmplfnd);
					}
# endif
				return(*tmplfnd++);
				}
			unput(*tmpllastch);
			}
		if (tmpltext[0] == 0  /* && feof(tmplin) */)
			{
			tmplsptr=tmplsbuf;
			return(0);
			}
#ifndef __cplusplus
		tmplprevious = tmpltext[0] = input();
		if (tmplprevious>0)
			output(tmplprevious);
#else
		tmplprevious = tmpltext[0] = lex_input();
		if (tmplprevious>0)
			lex_output(tmplprevious);
#endif
		tmpllastch=tmpltext;
# ifdef LEXDEBUG
		if(debug)putchar('\n');
# endif
		}
	}
#if defined(__cplusplus) || defined(__STDC__)
int tmplback(int *p, int m)
#else
tmplback(p, m)
	int *p;
#endif
{
	if (p==0) return(0);
	while (*p) {
		if (*p++ == m)
			return(1);
	}
	return(0);
}
	/* the following are only used in the lex library */
#if defined(__cplusplus) || defined(__STDC__)
int tmplinput(void)
#else
tmplinput()
#endif
{
#ifndef __cplusplus
	return(input());
#else
	return(lex_input());
#endif
	}
#if defined(__cplusplus) || defined(__STDC__)
void tmploutput(int c)
#else
tmploutput(c)
  int c; 
#endif
{
#ifndef __cplusplus
	output(c);
#else
	lex_output(c);
#endif
	}
#if defined(__cplusplus) || defined(__STDC__)
void tmplunput(int c)
#else
tmplunput(c)
   int c; 
#endif
{
	unput(c);
	}
