//
//	Note:  The use of this program shall be restricted to educational,
//	non-commercial use only.  All inquiries regarding licensing this
//	software for commercial use may be addressed to:
//	
//	Georgia Tech Research Corporation
//	Technology Licensing
//	Centennial Research Building - Rm. 275
//	400 Tenth Street, N.W.
//	Atlanta, Georgia  30332-0415
//	
//	*************************************************
//	
//	       Copyright 1996
//	Georgia Tech Research Corporation
//	    All Rights Reserved
//
//
//
// Test the parser along with the Template class.
//

#include <stdlib.h>
#include "Template.h"
#include "Error.h"

class Mercator;

// We have to have a global 'mercator'
Mercator *mercator = NULL;

main(int argc, char *argv[])
{
    if (!Template::ParseTemplateFile("/tmp/templates")) {
	Error(EL_ERROR, "Couldn't parse template file", NULL);
	exit(1);
    }
}

