#ifndef lint
static char attribsccsid[] = "@(#)yaccpar	1.9 (Berkeley) 02/21/93";
#endif
#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define attribclearin (attribchar=(-1))
#define attriberrok (attriberrflag=0)
#define YYRECOVERING (attriberrflag!=0)
#define YYPREFIX "attrib"

/*
//
//
//	Note:  The use of this program shall be restricted to educational,
//	non-commercial use only.  All inquiries regarding licensing this
//	software for commercial use may be addressed to:
//	
//	Georgia Tech Research Corporation
//	Technology Licensing
//	Centennial Research Building - Rm. 275
//	400 Tenth Street, N.W.
//	Atlanta, Georgia  30332-0415
//	
//	*************************************************
//	
//	       Copyright 1996
//	Georgia Tech Research Corporation
//	    All Rights Reserved
//
//
//
*/
    
extern void ProcessAttributeLine(char *name, int ftype, char *defaultname,
                                 int cltype);

#ifdef BEAM
int attriblineno;
#else
extern int attriblineno;
#endif
extern char* attribtext;

typedef union {
    long        integer;        /* integer return */
    char        *identifier;    /* identifier return */
} YYSTYPE;
#define IDENTIFIER 257
#define BOOLEAN 0
#define INTEGER 1
#define STRING 2
#define STRINGLIST 3
#define CLASS 1
#define APP 2
#define YYERRCODE 256
short attriblhs[] = {                                        -1,
    0,    3,    3,    4,    1,    1,    1,    1,    2,    2,
};
short attriblen[] = {                                         2,
    1,    0,    2,    4,    1,    1,    1,    1,    1,    1,
};
short attribdefred[] = {                                      2,
    0,    0,    0,    3,    7,    8,    5,    6,    0,    0,
   10,    9,    4,
};
short attribdgoto[] = {                                       1,
    9,   13,    2,    4,
};
short attribsindex[] = {                                      0,
    0, -257,    1,    0,    0,    0,    0,    0, -250,    4,
    0,    0,    0,
};
short attribrindex[] = {                                      0,
    0,    8,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,
};
short attribgindex[] = {                                      0,
    0,    0,    0,    0,
};
#define YYTABLESIZE 8
short attribtable[] = {                                       3,
    5,    6,    7,    8,   11,   12,   10,    1,
};
short attribcheck[] = {                                     257,
    0,    1,    2,    3,    1,    2,  257,    0,
};
#define YYFINAL 1
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 257
#if YYDEBUG
char *attribname[] = {
"end-of-file","INTEGER","STRING","STRINGLIST",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
"IDENTIFIER",
};
char *attribrule[] = {
"$accept : file",
"file : lines",
"lines :",
"lines : lines line",
"line : IDENTIFIER fieldtype IDENTIFIER classtype",
"fieldtype : STRING",
"fieldtype : STRINGLIST",
"fieldtype : BOOLEAN",
"fieldtype : INTEGER",
"classtype : APP",
"classtype : CLASS",
};
#endif
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 500
#define YYMAXDEPTH 500
#endif
#endif
int attribdebug;
int attribnerrs;
int attriberrflag;
int attribchar;
short *attribssp;
YYSTYPE *attribvsp;
YYSTYPE attribval;
YYSTYPE attriblval;
short attribss[YYSTACKSIZE];
YYSTYPE attribvs[YYSTACKSIZE];
#define attribstacksize YYSTACKSIZE

#include "attriblexer.c"

static int
attribwrap()
{
    return 1;
}



static int
attriberror(char *str)
{
    printf("attriberror: line: %d      %s  at  %s\n", attriblineno, str, attribtext);
    return 1;
}

#define YYABORT goto attribabort
#define YYREJECT goto attribabort
#define YYACCEPT goto attribaccept
#define YYERROR goto attriberrlab
int
attribparse()
{
    register int attribm, attribn, attribstate;
#if YYDEBUG
    register char *attribs;
    extern char *getenv();

    if (attribs = getenv("YYDEBUG"))
    {
        attribn = *attribs;
        if (attribn >= '0' && attribn <= '9')
            attribdebug = attribn - '0';
    }
#endif

    attribnerrs = 0;
    attriberrflag = 0;
    attribchar = (-1);

    attribssp = attribss;
    attribvsp = attribvs;
    *attribssp = attribstate = 0;

attribloop:
    if (attribn = attribdefred[attribstate]) goto attribreduce;
    if (attribchar < 0)
    {
        if ((attribchar = attriblex()) < 0) attribchar = 0;
#if YYDEBUG
        if (attribdebug)
        {
            attribs = 0;
            if (attribchar <= YYMAXTOKEN) attribs = attribname[attribchar];
            if (!attribs) attribs = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, attribstate, attribchar, attribs);
        }
#endif
    }
    if ((attribn = attribsindex[attribstate]) && (attribn += attribchar) >= 0 &&
            attribn <= YYTABLESIZE && attribcheck[attribn] == attribchar)
    {
#if YYDEBUG
        if (attribdebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, attribstate, attribtable[attribn]);
#endif
        if (attribssp >= attribss + attribstacksize - 1)
        {
            goto attriboverflow;
        }
        *++attribssp = attribstate = attribtable[attribn];
        *++attribvsp = attriblval;
        attribchar = (-1);
        if (attriberrflag > 0)  --attriberrflag;
        goto attribloop;
    }
    if ((attribn = attribrindex[attribstate]) && (attribn += attribchar) >= 0 &&
            attribn <= YYTABLESIZE && attribcheck[attribn] == attribchar)
    {
        attribn = attribtable[attribn];
        goto attribreduce;
    }
    if (attriberrflag) goto attribinrecovery;
#ifdef lint
    goto attribnewerror;
#endif
attribnewerror:
    attriberror("syntax error");
#ifdef lint
    goto attriberrlab;
#endif
attriberrlab:
    ++attribnerrs;
attribinrecovery:
    if (attriberrflag < 3)
    {
        attriberrflag = 3;
        for (;;)
        {
            if ((attribn = attribsindex[*attribssp]) && (attribn += YYERRCODE) >= 0 &&
                    attribn <= YYTABLESIZE && attribcheck[attribn] == YYERRCODE)
            {
#if YYDEBUG
                if (attribdebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *attribssp, attribtable[attribn]);
#endif
                if (attribssp >= attribss + attribstacksize - 1)
                {
                    goto attriboverflow;
                }
                *++attribssp = attribstate = attribtable[attribn];
                *++attribvsp = attriblval;
                goto attribloop;
            }
            else
            {
#if YYDEBUG
                if (attribdebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *attribssp);
#endif
                if (attribssp <= attribss) goto attribabort;
                --attribssp;
                --attribvsp;
            }
        }
    }
    else
    {
        if (attribchar == 0) goto attribabort;
#if YYDEBUG
        if (attribdebug)
        {
            attribs = 0;
            if (attribchar <= YYMAXTOKEN) attribs = attribname[attribchar];
            if (!attribs) attribs = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, attribstate, attribchar, attribs);
        }
#endif
        attribchar = (-1);
        goto attribloop;
    }
attribreduce:
#if YYDEBUG
    if (attribdebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, attribstate, attribn, attribrule[attribn]);
#endif
    attribm = attriblen[attribn];
    attribval = attribvsp[1-attribm];
    switch (attribn)
    {
case 4:
{ProcessAttributeLine(attribvsp[-3].identifier, attribvsp[-2].integer, attribvsp[-1].identifier, attribvsp[0].integer);}
break;
    }
    attribssp -= attribm;
    attribstate = *attribssp;
    attribvsp -= attribm;
    attribm = attriblhs[attribn];
    if (attribstate == 0 && attribm == 0)
    {
#if YYDEBUG
        if (attribdebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        attribstate = YYFINAL;
        *++attribssp = YYFINAL;
        *++attribvsp = attribval;
        if (attribchar < 0)
        {
            if ((attribchar = attriblex()) < 0) attribchar = 0;
#if YYDEBUG
            if (attribdebug)
            {
                attribs = 0;
                if (attribchar <= YYMAXTOKEN) attribs = attribname[attribchar];
                if (!attribs) attribs = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, attribchar, attribs);
            }
#endif
        }
        if (attribchar == 0) goto attribaccept;
        goto attribloop;
    }
    if ((attribn = attribgindex[attribm]) && (attribn += attribstate) >= 0 &&
            attribn <= YYTABLESIZE && attribcheck[attribn] == attribstate)
        attribstate = attribtable[attribn];
    else
        attribstate = attribdgoto[attribm];
#if YYDEBUG
    if (attribdebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *attribssp, attribstate);
#endif
    if (attribssp >= attribss + attribstacksize - 1)
    {
        goto attriboverflow;
    }
    *++attribssp = attribstate;
    *++attribvsp = attribval;
    goto attribloop;
attriboverflow:
    attriberror("yacc stack overflow");
attribabort:
    return (1);
attribaccept:
    return (0);
}
