//
//
//
//	Note:  The use of this program shall be restricted to educational,
//	non-commercial use only.  All inquiries regarding licensing this
//	software for commercial use may be addressed to:
//	
//	Georgia Tech Research Corporation
//	Technology Licensing
//	Centennial Research Building - Rm. 275
//	400 Tenth Street, N.W.
//	Atlanta, Georgia  30332-0415
//	
//	*************************************************
//	
//	       Copyright 1996
//	Georgia Tech Research Corporation
//	    All Rights Reserved
//
//
//
//

#include "mRegexp.h"
#include "mString.h"

mRegexp::mRegexp(void) : impl("") {}
mRegexp::mRegexp(const char *pattern) : impl(pattern) {}
mRegexp::mRegexp(const mRegexp &r) : impl(r.impl) {}
mRegexp::~mRegexp() {}

mRegexp& mRegexp::operator=(const mRegexp& r) {
  impl = r.impl; return *this;
}

mRegexp& mRegexp::operator=(const char *pattern) {
  impl = pattern;
  return *this; 
}

int mRegexp::index(const mString& str, unsigned int *len, 
		   unsigned int start) const {
  return impl.index(str.impl, len, start);
}

